import defs.PL
import defs.Explanation
import Queue
import copy

class Algorithm(object):
    '''
    classdocs
    '''


    def __init__(self, PL):
        self._PL = PL
        self._PFFG = PL.createPFFG()
        for rule in self._PFFG:
            print rule
        self._queueSize = 4096
        
    def explain(self, observations):
        
        ExplanationQueue = Queue.Queue(self._queueSize)
        ExplanationZero = defs.Explanation.Explanation(self._PL, observations)
        ExplanationQueue._put(ExplanationZero)
        
        # For each observation
        obsIndex=0
        for currentObs in observations:
            #print obsIndex, "Observation:"
            # Loop over all the explanations
            TempQueue = Queue.Queue(self._queueSize)
            while not ExplanationQueue.empty():              
                currentExp = ExplanationQueue._get()
                #print "\t current exp: "
                #print currentExp
                #print "\t currentexp AP=", currentExp.AP()
                # Extend Existing Plans
                letterAPIndex=0   
                for (letter, index) in currentExp.APWithNum():
                    # Removing terminals from the frontier
                    if letter == currentObs:
                        newFrontier = currentExp._frontier[:index-1] + currentExp._frontier[index+1:]
                        newOrder = currentExp.updateRemoving(index)
                        TempQueue._put(defs.Explanation.Explanation(self._PL, observations[obsIndex+1:], newFrontier, newOrder, currentExp.record))
                    
                    # Expanding the frontier
                    prodIndex=0
                    for rule in self._PFFG:
                            if rule._foot==currentObs and rule._root==letter:
                                newFrontier = currentExp._frontier[:index] + currentExp._frontier[index+1:]
                                newFrontier.extend(rule._alpha)
                                newOrder = currentExp.updateAdding(index, rule)
                                newRecord = currentExp._record[:]
                                newRecord.append((rule._pid, letter, index))
                                TempQueue._put(defs.Explanation.Explanation(self._PL, observations[obsIndex+1:], newFrontier, newOrder, newRecord))
                            prodIndex+=1
                            #end of: for rule in self._PFFG
                            
                    letterAPIndex+=1        
                    #end of: for letter in currentExp.AP()
                      
                # Introduce new plans
                for rule in self._PFFG:
                    if rule._foot==currentObs and (rule._root in self._PL._R):
                        newFrontier = currentExp._frontier[:]
                        newFrontier.extend(rule._alpha)
                        newOrder = currentExp.updateAdding(-1, rule)
                        newRecord = currentExp._record[:]
                        newRecord.append((rule._pid, rule._root, -1))
                        TempQueue._put(defs.Explanation.Explanation(self._PL, observations[obsIndex+1:], newFrontier, newOrder, newRecord))
                    #end of: for rule in self._PFFG:
                     
            ExplanationQueue = copy.copy(TempQueue)
            obsIndex+=1
            #end of: for currentObs in observations
            
        return ExplanationQueue
                    