import defs.Rule

class Explanation(object):
    '''
    classdocs
    '''


    def __init__(self, PL, observations=[], frontier=[], order=[], record=[]):
        '''
        Constructor
        '''
        self._PL = PL                       #Plan Library the explanation belong to
        self._observations=observations     #Observations still unexplained - must be of type Sigma
        self._frontier=frontier             #Next possible actions to observe - must be NT or Sigma
        self._order=order                   #Tuples of constraints such as (0,3) 
        self._record=record                 #Record of the substitutions that took place, such as <pid, frontier[i]>
        
        
    def __repr__(self):
        
        res = "Explanation:\n" + "\tObservations: " + str(self._observations) + "\n\tFrontier: " + str(self._frontier) + "\n\tOrder: " + str(self._order) + "\n\tRecord: " + str(self._record)
        return res
    
    
    # Get the explanation's AP (pending attachment points) - all of the next letters that can be used next
    def AP(self):
        r = defs.Rule.Rule(None,self._frontier,self._order)
        return r.leftMostChilds()
    
    def APWithNum(self):
        r = defs.Rule.Rule(None,self._frontier,self._order)
        return r.leftMostChildsWithNums()
    
    def UpdateRemoving(self, indexRemoved):
        newOrder = []

        for cons in self._order:
            if cons[0] == indexRemoved or cons[1] == indexRemoved:
                continue
            else:
                cons0 = (cons[0]-1 if cons[0] > indexRemoved else cons[0])
                cons1 = (cons[1]-1 if cons[1] > indexRemoved else cons[1])
                newOrder.append((cons0, cons1))
        return newOrder
    
    
    def updateAdding(self, indexRemoved, rule):
        newOrder = self.UpdateRemoving(indexRemoved) if indexRemoved > -1 else self._order[:]
        
        #why minus 1? since we removed one letter from the frontier
        indexOfNewCons = len(self._frontier)-1  if indexRemoved > -1 else len(self._frontier)
        
        for cons in rule._order:
            newOrder.append((cons[0]+indexOfNewCons, cons[1]+indexOfNewCons))
            
        return newOrder