import defs.Sigma
import defs.NT
import defs.Rule
import defs.PL
import defs.Tree
import defs.Explanation
import defs.Algorithm

if __name__ == '__main__':
    
    # Test Sigma and NT
    print "Test Sigmas and NTs:"
    sigma1 = defs.Sigma.Sigma('a')
    sigma2 = defs.Sigma.Sigma('b')
    sigma3 = defs.Sigma.Sigma('c')
    sigma4 = defs.Sigma.Sigma('X')      #should print an error
    
    nt1 = defs.NT.NT('X')
    nt2 = defs.NT.NT('Y')
    nt3 = defs.NT.NT('A')
    nt4 = defs.NT.NT('B')
    nt5 = defs.NT.NT('C')
    nt6 = defs.NT.NT('Z')
    nt7 = defs.NT.NT('a')            #should print an error

    print sigma1, sigma2, nt1, nt2
    
    # Test Rule
    print "\n\nTest Rules:"
    # X -> ABC | []
    rule1 = defs.Rule.Rule(nt1, [nt3, nt4, nt5], [])
    print rule1
    print "    right childs: ", rule1.rightChilds()             #[]
    print "    leftmost childs: ", rule1.leftMostChilds()       #[A,B,C]
    # Y -> AB | [(A<B)]
    rule2 = defs.Rule.Rule(nt2, [nt3, nt4], [(0, 1)])
    print rule2
    print "    right childs: ", rule2.rightChilds()             #[B]
    print "    leftmost childs: ", rule2.leftMostChilds()       #[A]
    # Z -> AC | [(A<C)]
    rule3 = defs.Rule.Rule(nt6, [nt3, nt5], [(0, 1)])
    print rule3
    # Z -> ABX | [(A<B),(A<X)]
    rule4 = defs.Rule.Rule(nt6, [nt3, nt4, nt1], [(0, 1), (0, 2)])
    print rule4
    print "    right childs: ", rule4.rightChilds()             #[B,X]
    print "    leftmost childs: ", rule4.leftMostChilds()       #[A]
    # A -> a
    rule5 = defs.Rule.Rule(nt3, [sigma1], [])
    print rule5
    print "    right childs: ", rule5.rightChilds()             #[]
    print "    leftmost childs: ", rule5.leftMostChilds()       #[a]
    # B -> b
    rule6 = defs.Rule.Rule(nt4, [sigma2], [])
    print rule6
    # C -> c
    rule7 = defs.Rule.Rule(nt5, [sigma3], [])
    print rule7
    # Cannot allow rules of this type, but can be avoided using B->b
    # Y -> AbC | [(A<b),(b<C)]
    #rule8 = defs.Rule.Rule(nt2, [nt3, sigma2, nt5], [(nt3,sigma2),(sigma2,nt5)])
    #print rule8
    
    # Test PL
    print "\n\nTest PL:"
    sigmas = [sigma1, sigma2, sigma3]
    nts = [nt1, nt2, nt3, nt4, nt5, nt6]
    goals = [nt1, nt2]
    rules = [rule1, rule2, rule3, rule4, rule5, rule6, rule7]
    myPL = defs.PL.PL(sigmas, nts, goals, rules)
    print myPL
    
    #Test Tree
    a_Tree = defs.Tree.Tree("Basic", sigma1, [], [], myPL)
    print a_Tree
    b_Tree = defs.Tree.Tree("Basic", sigma2, [], [], myPL)
    c_Tree = defs.Tree.Tree("Basic", sigma3, [], [], myPL)
    X_Tree = defs.Tree.Tree("Basic", nt1, [], [], myPL)
    print X_Tree
    Y_Tree = defs.Tree.Tree("Basic", nt2, [], [], myPL)
    A_Tree = defs.Tree.Tree("Basic", nt3, [], [], myPL)
    B_Tree = defs.Tree.Tree("Basic", nt4, [], [], myPL)
    C_Tree = defs.Tree.Tree("Basic", nt5, [], [], myPL)
    Aa_Tree = defs.Tree.Tree("Complex", nt3, rule5, [a_Tree], myPL)    
    print Aa_Tree
    Bb_Tree = defs.Tree.Tree("Complex", nt4, rule6, [b_Tree], myPL)  
    print Bb_Tree
    
    # Test Tree.matchLeftTree
    print "\n\nTest Tree.matchLeftTree"
    print "Foot of the following tree (should be a):", Aa_Tree.isLeftMostTree()
    print Aa_Tree
    X_ABC_b_Tree = defs.Tree.Tree("Complex", nt1, [], [A_Tree, Bb_Tree, C_Tree], myPL)
    print "Foot of the following tree (should be b):", X_ABC_b_Tree.isLeftMostTree()
    print X_ABC_b_Tree
    X_ABC_Tree = defs.Tree.Tree("Complex", nt1, [], [A_Tree, B_Tree, C_Tree], myPL)
    print "Foot of the following tree (should be False):", X_ABC_Tree.isLeftMostTree()
    print X_ABC_Tree
    X_ABC_ab_Tree = defs.Tree.Tree("Complex", nt1, [], [Aa_Tree, Bb_Tree, C_Tree], myPL)
    print "Foot of the following tree (should be False):", X_ABC_ab_Tree.isLeftMostTree()
    print X_ABC_ab_Tree
    Z_ABX_ABC_b_Tree = defs.Tree.Tree("Complex", nt6, [], [A_Tree, B_Tree, X_ABC_b_Tree], myPL)
    print "Foot of the following tree (should be b):", Z_ABX_ABC_b_Tree.isLeftMostTree()
    print Z_ABX_ABC_b_Tree
    Z_ABX_b_Tree = defs.Tree.Tree("Complex", nt6, [], [A_Tree, Bb_Tree, X_Tree], myPL)
    print "Foot of the following tree (should be False, since A<B according to the rules):", Z_ABX_b_Tree.isLeftMostTree()
    print Z_ABX_b_Tree
    Z_ABX_a_Tree = defs.Tree.Tree("Complex", nt6, [], [Aa_Tree, B_Tree, X_Tree], myPL)
    print "Foot of the following tree (should be a):", Z_ABX_a_Tree.isLeftMostTree()
    print Z_ABX_a_Tree
    Z_ABX_aABC_a_Tree = defs.Tree.Tree("Complex", nt6, [], [Aa_Tree, B_Tree, X_ABC_b_Tree], myPL)
    print "Foot of the following tree (should be False):", Z_ABX_aABC_a_Tree.isLeftMostTree()
    print Z_ABX_aABC_a_Tree
    
    
    #Test PL.createTrees
    print "\n\nTest PL.createTrees"
    print myPL
    G_PL = myPL.generatingSet()
    for tree in G_PL:
        print "Tree below is leftmost: ", tree.isLeftMostTree()
        print tree._rule
        print tree
    
    # X -> ABC | [(B<C)]
    changedRule1 = defs.Rule.Rule(nt1, [nt3, nt4, nt5], [(1,2)])
    # Z -> ABX | [(X<A),(X<B)]
    changedRule4 =  defs.Rule.Rule(nt6, [nt3, nt4, nt1], [(2, 0), (2, 1)])
    changedRules = [changedRule1, rule2, rule3, changedRule4, rule5, rule6, rule7] 
    mySecondPL = defs.PL.PL(sigmas, nts, goals, changedRules)    
        
    #Test PL.createTrees2
    print "\n\nTest PL.createTrees2"
    print mySecondPL
    G_PL = mySecondPL.generatingSet()
    for tree in G_PL:
        print "Tree below is leftmost: ", tree.isLeftMostTree()
        print tree._rule
        print tree
            
    #Test Tree.treeToList
    print "\n\nTest Tree.treeToList"
    print Aa_Tree.treeToList()                      # should be [a]
    print X_ABC_b_Tree.treeToList()                 # should be [A, b, C]
    print X_ABC_b_Tree.treeConstraints()            # should be []
    print Z_ABX_ABC_b_Tree.treeToList()             # should be [A, B, A, b, C]
    print Z_ABX_ABC_b_Tree.treeConstraints()        # should be [(0, 1)]
    print "\n\nTest Tree.treeConstraints"
    b_Tree = defs.Tree.Tree("Basic", sigma2, [], [], mySecondPL)
    X_Tree = defs.Tree.Tree("Basic", nt1, [], [], mySecondPL)
    A_Tree = defs.Tree.Tree("Basic", nt3, [], [], mySecondPL)
    B_Tree = defs.Tree.Tree("Basic", nt4, [], [], mySecondPL)
    C_Tree = defs.Tree.Tree("Basic", nt5, [], [], mySecondPL)
    Bb_Tree = defs.Tree.Tree("Complex", nt4, rule6, [b_Tree], mySecondPL)
    X_ABC_b_Tree = defs.Tree.Tree("Complex", nt1, changedRule1, [A_Tree, Bb_Tree, C_Tree], mySecondPL)
    Z_ABX_ABC_b_Tree = defs.Tree.Tree("Complex", nt6, changedRule4, [A_Tree, B_Tree, X_ABC_b_Tree], mySecondPL)
    print Z_ABX_ABC_b_Tree
    print Z_ABX_ABC_b_Tree.treeToList()         #should be [A, B, A, b, C]
    print Z_ABX_ABC_b_Tree.treeConstraints()    #should be [(2, 0), (3, 0), (4, 0), (2, 1), (3, 1), (4, 1), (3, 4)]
    
    
    #Test PL.createPFFG
    print "\n\nTest PL.createPFFG"
    PL1_pffg = myPL.createPFFG()
    for rule in PL1_pffg:
        print rule
        
    print "\n\nTest PL2.createPFFG"
    PL2_pffg = mySecondPL.createPFFG()
    for rule in PL2_pffg:
        print rule
        
    #Test Explanation
    print "\n\nTest Explanation"
    explain1 = defs.Explanation.Explanation(myPL, [sigma1, sigma2, sigma3], [nt1])
    explain2 = defs.Explanation.Explanation(myPL, [sigma1, sigma2, sigma3], [nt3, nt4, nt5], [(0,1)])
    print explain1
    print explain1.AP()     # should be [X]
    print explain2
    print explain2.AP()     # should be [A, C]
    
    #Test Algorithm :)
    print "\n\nTest Algorithm :)"
    algo = defs.Algorithm.Algorithm(myPL)
    exps = algo.explain([sigma1, sigma2, sigma3])
    while not exps.empty():
        exp = exps._get()
        print exp
        
        
    algo2 = defs.Algorithm.Algorithm(mySecondPL)
    exps = algo2.explain([sigma1, sigma2, sigma3])
    while not exps.empty():
        exp = exps._get()
        print exp
    
    myThirdPL =  defs.PL.PL(sigmas, nts, [nt1, nt2, nt6], changedRules)     #Added Z to goals...
    print myThirdPL   
    algo3 = defs.Algorithm.Algorithm(myThirdPL)
    exps = algo3.explain([sigma1, sigma2, sigma3])
    while not exps.empty():
        exp = exps._get()
        print exp
        